// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "Collider2D.hpp"
#include "physics/2d/Box.hpp"

namespace Dawn {
  class BoxCollider : public Collider2D {
    public:
      // @optional
      glm::vec2 min = glm::vec2(-0.5f, -0.5f);
      // @optional
      glm::vec2 max = glm::vec2( 0.5f,  0.5f);

      BoxCollider(SceneItem *item);
      enum Collider2DType getColliderType() override;
  };
}